/*
 * Read/write alliance data
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

static UB2 allydata[12];
static bool allyread=false;

void read_allydata()
{
  FILE *handle;
  int rnum;

  handle=mkopen("grey.hst",false,'r');
  if (!handle) return;

  fseek(handle,1822,SEEK_SET);

  for(rnum=1;rnum<=11;rnum++) {
    allydata[rnum]=readUB2(handle);
  }

  fclose(handle);
  allyread=true;
}

bool write_allydata()
{
  FILE *handle;
  bool v;

  handle=mkopen("grey.hst",true,'w');
  if (!handle) return NULL;

  fseek(handle,1822,SEEK_SET);

  v=true;
  for(int rnum=1;rnum<=11;rnum++) {
    if (v) v=writeUB2(handle,allydata[rnum]);
  }

  fclose(handle);
  return v;
}

bool isally(int rnumfrom,int rnumto)
{
  if (rnumfrom<1 || rnumfrom>11 || rnumto<1 || rnumto>11) {
    return false;
  }
  if (!allyread) {
    read_allydata();
  }
  if (!allyread) {
    return false;
  }
  return (allydata[rnumfrom] & 1<<(rnumto-1));
}

void setally(int rnumfrom,int rnumto,bool allying)
{
  if (rnumfrom<1 || rnumfrom>11 || rnumto<1 || rnumto>11) {
    return;
  }
  if (!allyread) {
    read_allydata();
  }
  if (!allyread) {
    return;
  }
  if (allying) {
    allydata[rnumfrom] |= (UB2)1<<(rnumto-1);
  } else {
    allydata[rnumfrom] &= (UB2)~(1<<(rnumto-1));
  }
  write_allydata();
}
