/*
 * Read/write messages
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

int num_outmess()
{
  FILE *handle;
  int ns;

  handle=mkopen("messpnt.tmp",false,'r');
  if (!handle) return 0;

  ns=(int)readUB2(handle);
  fclose(handle);
  return ns;
}

OUTMESS *read_outmess(int mnum)
{
  FILE *handlep,*handle;
  OUTMESS *str;
  UB2 ns;

  handle=mkopen("mess.tmp",false,'r');
  if (!handle) return NULL;

  handlep=mkopen("messpnt.tmp",false,'r');
  if (!handlep) {
    fclose(handle);
    return NULL;
  }

  ns=readUB2(handlep);
  if (mnum>ns || mnum==0) {
    fclose(handle);
    fclose(handlep);
    return NULL;
  }

  fseek(handlep,2+8*(mnum-1),SEEK_SET);

  str=new OUTMESS;
  if (!str) {
    fclose(handle);
    fclose(handlep);
    return NULL;
  }

  str->iTo=readUB2(handlep);
  str->lOffset=readUB4(handlep);
  str->wLength=readUB2(handlep);

  fseek(handle,str->lOffset-1,SEEK_SET);

  str->sMessage=readXStringD(handle,str->wLength);

  fclose(handle);
  fclose(handlep);
  return str;
}

OUTMESS *read_all_outmess()
{
  FILE *handlep,*handle;
  OUTMESS *str;
  int mnum,mmax;

  mmax=num_outmess();

  handle=mkopen("mess.tmp",false,'r');
  if (!handle) return NULL;

  handlep=mkopen("messpnt.tmp",false,'r');
  if (!handlep) {
    fclose(handle);
    return NULL;
  }

  str=new OUTMESS [mmax+1];
  if (!str) {
    fclose(handle);
    fclose(handlep);
    return NULL;
  }

  fseek(handlep,2,SEEK_SET);

  for(mnum=1;mnum<=mmax;mnum++) {
    str[mnum].iTo=readUB2(handlep);
    str[mnum].lOffset=readUB4(handlep);
    str[mnum].wLength=readUB2(handlep);

    fseek(handle,str[mnum].lOffset-1,SEEK_SET);

    str[mnum].sMessage=readXStringD(handle,str[mnum].wLength);
  }

  fclose(handle);
  fclose(handlep);
  return str;
}

bool write_outmess(int mnum,OUTMESS *str)
{
  FILE *handle,*handlep;
  UB2 ns;
  bool v;

  handle=mkopen("mess.tmp",false,'w');
  if (!handle) return NULL;

  handlep=mkopen("messpnt.tmp",false,'w');
  if (!handlep) {
    fclose(handle);
    return NULL;
  }

  str->wLength=str->sMessage.Len();

  ns=readUB2(handlep);
  if (mnum>ns || mnum==0) {
    mnum=++ns;
    fseek(handlep,0,SEEK_SET);
    v=writeUB2(handlep,ns);
    fseek(handle,0,SEEK_END);
  } else {
    UB2 oo;
    UB2 olen;
    fseek(handlep,2+8*(mnum-1),SEEK_SET);
    readUB2(handle);
    oo=readUB2(handle);
    readUB2(handle);
    olen=readUB2(handle);
    if (olen<str->wLength) {
      fseek(handle,0,SEEK_END);
    } else {
      fseek(handle,oo-1,SEEK_SET);
    }
    v=true;
  }
  str->lOffset=ftell(handle)+1;

  if (v) v=writeXStringD(handle,str->wLength,str->sMessage);

  fseek(handlep,2+8*(mnum-1),SEEK_SET);

  if (v) v=writeUB2(handlep,str->iTo);
  if (v) v=writeUB4(handlep,str->lOffset);
  if (v) v=writeUB2(handlep,str->wLength);

  fclose(handle);
  fclose(handlep);
  return v;
}

bool del_outmess(int mnum)
{
  FILE *handlep;
  OUTMESS *str;
  UB2 ns;
  bool v;

  str=read_outmess(mnum);
  if (!str) return false;
  delete str;

  str=read_outmess(num_outmess());

  handlep=mkopen("messpnt.tmp",false,'w');
  if (!handlep) {
    fclose(handlep);
    delete str;
    return NULL;
  }

  ns=readUB2(handlep);
  ns--;
  fseek(handlep,0,SEEK_SET);
  v=writeUB2(handlep,ns);

  if (mnum<=ns) {
    fseek(handlep,2+8*(mnum-1),SEEK_SET);

    if (v) v=writeUB2(handlep,str->iTo);
    if (v) v=writeUB4(handlep,str->lOffset);
    if (v) v=writeUB2(handlep,str->wLength);
  } else {
    fseek(handlep,2+8*(ns),SEEK_SET);

    if (v) v=writeUB2(handlep,0);
    if (v) v=writeUB4(handlep,0);
    if (v) v=writeUB2(handlep,0);
  }

  delete str;

  fclose(handlep);
  return v;
}
