/*
 * Read/write incoming messages
 * part of the Player-Toolkit package
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

int num_inmess()
{
  FILE *handle;
  int ns;

  handle=mkopen("mdata&p.dat",false,'r');
  if (!handle) return 0;

  ns=(int)readUB2(handle);
  fclose(handle);
  return ns;
}

INMESS *read_inmess(int mnum)
{
  FILE *handle;
  INMESS *str;
  UB2 ns;

  handle=mkopen("mdata&p.dat",false,'r');
  if (!handle) return NULL;

  ns=readUB2(handle);
  if (mnum>ns || mnum==0) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,2+6*(mnum-1),SEEK_SET);

  str=new INMESS;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->lOffset=readUB4(handle);
  str->wLength=readUB2(handle);

  fseek(handle,str->lOffset-1,SEEK_SET);

  str->sMessage=readXStringD(handle,str->wLength);

  fclose(handle);
  return str;
}

bool del_inmess(int mnum)
{
  FILE *handle;
  INMESS *str;
  UB2 ns;
  bool v;

  str=read_inmess(mnum);
  if (!str) return false;

  handle=mkopen("mdata&p.dat",false,'w');
  if (!handle) return false;

  ns=readUB2(handle);
  ns--;
  fseek(handle,0,SEEK_SET);
  v=writeUB2(handle,ns);

  if (mnum<=ns) {
    fseek(handle,2+6*(mnum-1),SEEK_SET);

    if (v) v=writeUB4(handle,str->lOffset);
    if (v) v=writeUB2(handle,str->wLength);
  }

  fclose(handle);
  return v;
}

INMESS *read_all_inmess()
{
  FILE *handle;
  INMESS *str;
  int vnum,vmax;

  vmax=num_inmess();
  if (vmax==0) return NULL;

  handle=mkopen("mdata&p.dat",true,'r');
  if (!handle) return NULL;

  str=new INMESS [vmax+1];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  for(vnum=1;vnum<=vmax;vnum++) {

    fseek(handle,2+6*(vnum-1),SEEK_SET);

    str[vnum].lOffset=readUB4(handle);
    str[vnum].wLength=readUB2(handle);

    fseek(handle,str[vnum].lOffset-1,SEEK_SET);

    str[vnum].sMessage=readXStringD(handle,str[vnum].wLength);
  }

  fclose(handle);
  return str;
}
