/*
 * Read scanned ship data
 * part of the Player-Toolkit package
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

int num_targets()
{
  FILE *handle;
  int ns;

  handle=mkopen("target&p.dat",false,'r');
  if (!handle) return 0;

  ns=(int)readUB2(handle);
  fclose(handle);
  return ns;
}

TARGETDATA *read_targetdata(int tnum)
{
  FILE *handle;
  TARGETDATA *str;
  UB2 ns;

  handle=mkopen("target&p.dat",false,'r');
  if (!handle) return NULL;

  ns=readUB2(handle);
  if (tnum>ns || tnum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,2+34*(tnum-1),SEEK_SET);

  str=new TARGETDATA;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->wID=readUB2(handle);
  str->wRace=readUB2(handle);
  str->wWarp=readUB2(handle);
  str->pos.x=readUB2(handle);
  str->pos.y=readUB2(handle);
  str->wHull=readUB2(handle);
  str->wBearing=readUB2(handle);
  str->sName=readXString(handle,20);

  fclose(handle);
  return str;
}

SHIPXY *read_shipxy(int snum)
{
  FILE *handle;
  SHIPXY *str;

  handle=mkopen("shipxy&p.dat",false,'r');
  if (!handle) return NULL;

  if (snum>500 || snum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,8*(snum-1),SEEK_SET);

  str=new SHIPXY;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->pos.x=readUB2(handle);
  str->pos.y=readUB2(handle);
  str->wOwner=readUB2(handle);
  str->wMass=readUB2(handle);

  fclose(handle);
  return str;
}

TARGETDATA * read_all_targetdata()
{
  FILE *handle;
  TARGETDATA *str;
  int k,tnum,tmax;
  UB2 tid;

  tmax=num_targets();
  if (tmax==0) return NULL;

  handle=mkopen("target&p.dat",false,'r');
  if (!handle) return NULL;

  str=new TARGETDATA [501];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  for(k=1;k<501;k++) {
    str[k].wID=0;
  }

  fseek(handle,2,SEEK_SET);

  for (tnum=1;tnum<=tmax;tnum++) {
    tid=readUB2(handle);
    str[tid].wID=tid;
    str[tid].wRace=readUB2(handle);
    str[tid].wWarp=readUB2(handle);
    str[tid].pos.x=readUB2(handle);
    str[tid].pos.y=readUB2(handle);
    str[tid].wHull=readUB2(handle);
    str[tid].wBearing=readUB2(handle);
    str[tid].sName=readXString(handle,20);
  }

  fclose(handle);
  return str;
}

SHIPXY * read_all_shipxy()
{
  FILE *handle;
  SHIPXY *str;
  int k,snum;

  handle=mkopen("shipxy&p.dat",false,'r');
  if (!handle) return NULL;

  str=new SHIPXY [501];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  for(k=1;k<501;k++) {
    str[k].wOwner=0;
    str[k].wMass=0;
  }

  fseek(handle,2,SEEK_SET);

  for (snum=1;snum<=500;snum++) {
    str[snum].pos.x=readUB2(handle);
    str[snum].pos.y=readUB2(handle);
    str[snum].wOwner=readUB2(handle);
    str[snum].wMass=readUB2(handle);
  }

  fclose(handle);
  return str;
}
